(function () {
    if (window.fund && window.fundDetail) {
        return;
    }
    var responseCallbacks = {};
    var uniqueId = 1;

    function getOptionFundState(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.getOptionFundState(jsonStr);
    }

    function addOptionFund(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.addOptionFund(jsonStr);
    }

    function deleteOptionFund(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.deleteOptionFund(jsonStr);
    }

    function topOptionFund(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.topOptionFund(jsonStr);
    }

    function setCalendarRemind(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.setCalendarRemind(jsonStr);
    }

    function openCalendarRemind(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.openCalendarRemind(jsonStr);
    }

    function queryCalendarRemind(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.queryCalendarRemind(jsonStr);
    }

    function emBuyFund(params) {
///        console.log('detail_interaction emBuyFund');

        var jsonStr = generateCallbackId(params);
        fundModule.emBuyFund(jsonStr);
    }

    function userLogin(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.userLogin(jsonStr);
    }

    function shareFundDetail(params) {
///        console.log('detail_interaction shareFundDetail');

        var jsonStr = generateCallbackId(params);
        fundModule.shareFundDetail(jsonStr);
    }

    function getFundDetail(params) {
///        console.log('detail_interaction getFundDetail');

        var jsonStr = generateCallbackId(params);
        fundModule.getFundDetail(jsonStr);
    }

    function setNavigationBarTitle(params) {
///        console.log('detail_interaction setNavigationBarTitle');

        var jsonStr = generateCallbackId(params);
        fundModule.setNavigationBarTitle(jsonStr);
    }

    function setNavigationBarColor(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.setNavigationBarColor(jsonStr);
    }

    function setNavigationBar(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.setNavigationBar(jsonStr);
    }

    function setNavigationBarScroll(params) {
///        console.log('detail_interaction setNavigationBarScroll');

        var jsonStr = generateCallbackId(params);
        fundModule.setNavigationBarScroll(jsonStr);
    }

    function jumpBigChartView(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.jumpBigChartView(jsonStr);
    }

    function jumpBigChartPage(params) {
         var jsonStr = generateCallbackId(params);
         fundModule.jumpBigChartPage(jsonStr);
    }

    function closeBigChartPage(params) {
         var jsonStr = generateCallbackId(params);
         fundModule.closeBigChartPage(jsonStr);
    }

    function chartViewClose(params) {
         var jsonStr = generateCallbackId(params);
         fundModule.chartViewClose(jsonStr);
    }

    function recordBrowseFund(params) {
///        console.log('detail_interaction recordBrowseFund');

        var jsonStr = generateCallbackId(params);
        fundModule.recordBrowseFund(jsonStr);
    }

    function startRefresh(params) {
///        console.log('detail_interaction startRefresh');

        var jsonStr = generateCallbackId(params);
        fundModule.startRefresh(jsonStr);
    }

    function endRefresh(params) {
///        console.log('detail_interaction endRefresh');

        var jsonStr = generateCallbackId(params);
        fundModule.endRefresh(jsonStr);
    }

    function stopHorizontalScroll(params) {
///        console.log('detail_interaction stopHorizontalScroll');

        var jsonStr = generateCallbackId(params);
        fundModule.stopHorizontalScroll(jsonStr);
    }

    function openHorizontalScroll(params) {
///        console.log('detail_interaction openHorizontalScroll');

        var jsonStr = generateCallbackId(params);
        fundModule.openHorizontalScroll(jsonStr);
    }

    function showCommentView(params) {
///        console.log('detail_interaction showCommentView');

        var jsonStr = generateCallbackId(params);
        fundModule.showCommentView(jsonStr);
    }

    function getBarInteract(params) {
///        console.log('detail_interaction getBarInteract');

        var jsonStr = generateCallbackId(params);
        fundModule.getBarInteract(jsonStr);
    }

    function setBarInteract(params) {
///        console.log('detail_interaction setBarInteract');

        var jsonStr = generateCallbackId(params);
        fundModule.setBarInteract(jsonStr);
    }

    function hideDetailLoading(params) {
///        console.log('detail_interaction hideDetailLoading');

        var jsonStr = generateCallbackId(params);
        fundModule.hideDetailLoading(jsonStr);
    }

    function setVideoData(params) {
//        console.log('detail_interaction setVideoData');

        var jsonStr = generateCallbackId(params);
        fundModule.setVideoData(jsonStr);
    }

    function setVideoView(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.setVideoView(jsonStr);
    }

    function onVideoVisible(params) {
//        console.log('detail_interaction onVideoVisible');

        var jsonStr = generateCallbackId(params);
        fundModule.onVideoVisible(jsonStr);
    }

    function onVideoInvisible(params) {
//        console.log('detail_interaction onVideoInvisible');

        var jsonStr = generateCallbackId(params);
        fundModule.onVideoInvisible(jsonStr);
    }


    function navigateToApp(params) {
///        console.log('detail navigateToApp');

        var jsonStr = generateCallbackId(params);
        fundModule.navigateToApp(jsonStr);
    }

    function navigateToAppAndClose(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.navigateToAppAndClose(jsonStr);
    }

    function navigateToMiniProgram(params) {
///        console.log('detail_interaction navigateToMiniProgram');

        var jsonStr = generateCallbackId(params);
        fundModule.navigateToMiniProgram(jsonStr);
    }

    function navigateBack(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.navigateBack(jsonStr);
    }


    function request(params) {
///        console.log('detail_interaction request:' + JSON.stringify(params));

        var jsonStr = generateCallbackId(params);
        fundModule.request(jsonStr);
    }

    function getUserInfoSync(params) {
///        console.log('detail_interaction getUserInfoSync');

        return JSON.parse(fundModule.getUserInfoSync(params));
    }

    function getUrlConfigSync(params) {
///        console.log('detail_interaction getUrlConfigSync');

        var jsonStr = generateCallbackId(params);
        return fundModule.getUrlConfigSync(jsonStr);
    }

    function getSystemInfoSync(params) {
///        console.log('detail_interaction getSystemInfoSync');

        var jsonStr = generateCallbackId(params);
        return JSON.parse(fundModule.getSystemInfoSync(jsonStr));
    }

    function showToast(params) {
///        console.log('detail_interaction showToast');

        var jsonStr = generateCallbackId(params);
        fundModule.showToast(jsonStr);
    }

    function hideToast(params) {
///        console.log('detail_interaction hideToast');

        var jsonStr = generateCallbackId(params);
        fundModule.hideToast(jsonStr);
    }

    function showLoading(params) {
///        console.log('detail_interaction showLoading');

        var jsonStr = generateCallbackId(params);
        fundModule.showLoading(jsonStr);
    }

    function hideLoading(params) {
///        console.log('detail_interaction hideLoading');

        var jsonStr = generateCallbackId(params);
        fundModule.hideLoading(jsonStr);
    }

    function showModal(params) {
///        console.log('detail_interaction showModal');

        var jsonStr = generateCallbackId(params);
        fundModule.showModal(jsonStr);
    }

    function showActionSheet(params) {
///        console.log('detail_interaction showActionSheet');

        var jsonStr = generateCallbackId(params);
        fundModule.showActionSheet(jsonStr);
    }


    function getNetworkType(params) {
///        console.log('detail_interaction getNetworkType');

        var jsonStr = generateCallbackId(params);
        fundModule.getNetworkType(jsonStr);
    }

    function reportMonitor(params) {
///        console.log('detail_interaction reportMonitor');

        var jsonStr = generateCallbackId(params);
        fundModule.reportMonitor(jsonStr);
    }

    function setStorage(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.setStorage(jsonStr);
    }

    function setStorageSync(params) {
        var jsonStr = generateCallbackId(params);
        return fundModule.setStorageSync(jsonStr);
    }

    function getStorage(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.getStorage(jsonStr);
    }

    function getStorageSync(key, params) {
        return fundModule.getStorageSync(key, params);
    }

    function removeStorage(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.removeStorage(jsonStr);
    }

    function removeStorageSync(key, params) {
        return fundModule.removeStorageSync(params);
    }

    function clearStorage(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.clearStorage(jsonStr);
    }

    function clearStorageSync(params) {
        return fundModule.clearStorageSync(params);
    }

    function presentPage(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.presentPage(jsonStr);
    }

    function setMemory(params) {
        //兼容object参数
        if (typeof params == 'object') {
            var jsonStr = generateCallbackId(params);
            return fundModule.setMemory(jsonStr);
        }
        return fundModule.setMemory(params);
    }

    function getMemory(key) {
        return fundModule.getMemory(key);
    }

    function removeMemory(key) {
        return fundModule.removeMemory(key);
    }

    function clearMemory(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.clearMemory(jsonStr);
    }

    function previewImage(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.previewImage(jsonStr);
    }

    function setCommonStorage(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.setCommonStorage(jsonStr);
    }

    function setCommonStorageSync(params) {
        var jsonStr = generateCallbackId(params);
        return fundModule.setCommonStorageSync(jsonStr);
    }

    function getCommonStorage(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.getCommonStorage(jsonStr);
    }

    function getCommonStorageSync(params) {
        return fundModule.getCommonStorageSync(params);
    }

    function removeCommonStorage(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.removeCommonStorage(jsonStr);
    }

    function removeCommonStorageSync(params) {
        return fundModule.removeCommonStorageSync(params);
    }

    function hideFloatingVideoView(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.hideFloatingVideoView(params);
    }

    function getPageStorageSync(params) {
        return fundModule.getPageStorageSync(params);
    }

    function setPageStorageSync(params) {
        var jsonStr = generateCallbackId(params);
        return fundModule.setPageStorageSync(jsonStr);
    }

    function getCostShowStateSync(params) {
        var jsonStr = generateCallbackId(params);
        return fundModule.getCostShowStateSync(jsonStr);
    }

    function onNativeMessageRegistered(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.onNativeMessageRegistered(params);
    }

    function getABTestSync(params) {
        return fundModule.getABTestSync(params);
    }

    function showPortfolioEditDialog(params) {
        var jsonStr = generateCallbackId(params);
        fundModule.showPortfolioEditDialog(jsonStr);
    }

    function on(params) {
        var jsonStr = generateCallbackId(params);
        return fundModule.on(jsonStr);
    }

    function emit(params) {
        var jsonStr = generateCallbackId(params);
        return fundModule.emit(jsonStr);
    }

    function off(params) {
        var jsonStr = generateCallbackId(params);
        return fundModule.off(jsonStr);
    }

    function offAll(params) {
        var jsonStr = generateCallbackId(params);
        return fundModule.off(jsonStr);
    }

    function shareFundToDesktop(params) {
        var jsonStr = generateCallbackId(params);
        return fundModule.shareFundToDesktop(jsonStr);
    }

    /**
     * 提供给native调用. 多次回调
     */
    function _invokeJSCallbackAndKeepAlive(callbackJson) {
        execInvokeMethod(callbackJson);
    }

    /**
     * 提供给native调用. 一次性回调
     */
    function _invokeJSCallback(callbackJson) {
        var callbackId = execInvokeMethod(callbackJson);
        if (callbackId) {
            delete responseCallbacks[callbackId];
        }
    }

    function _postMessageToWeb(jsonData) {
        var messageEvent = document.createEvent("Event");
        messageEvent.initEvent("message", true, true);
        var jsonObject = JSON.parse(jsonData);
        messageEvent.data = jsonObject.data;
        messageEvent.origin = jsonObject.origin;
        window.dispatchEvent(messageEvent);
    }

    function execInvokeMethod(callbackJson) {
        var message = JSON.parse(callbackJson);
        if (message.callbackId) {
            var responseCallback = responseCallbacks[message.callbackId];
            if (!responseCallback) {
                return;
            }

            var res = message;
            responseCallback(res);
            return message.callbackId;
        }
        return undefined;
    }

    function generateCallbackId(params) {
        var convertFunction = function (json) {
            if (params.success || params.fail || params.complete) {
                if (json.code === 1) {
                    params.success ? params.success(json.data) : ''
                } else {
                    params.fail ? params.fail(json.data) : ''
                }
                params.complete ? params.complete(json.data) : json
            }
        };

        var callbackId = 'fund_' + (uniqueId++) + '_' + new Date().getTime();
        responseCallbacks[callbackId] = convertFunction;
        if ((typeof params == 'string') && params.constructor == String) {
            return params;
        } else {
            if (params == undefined) {
                params = {};
            }
            params.callbackId = callbackId;
            return JSON.stringify(params);
        }
    }

    var fund = window.fund = {
        getSystemInfoSync,
        request,
        getUserInfoSync,
        getUrlConfigSync,
        navigateBack,
        navigateToApp,
        navigateToMiniProgram,
        showToast,
        hideToast,
        showLoading,
        hideLoading,
        showModal,
        showActionSheet,
        getNetworkType,
        reportMonitor,
        getStorage,
        getStorageSync,
        setStorage,
        setStorageSync,
        removeStorage,
        removeStorageSync,
        clearStorage,
        clearStorageSync,
        presentPage,
        setMemory,
        getMemory,
        removeMemory,
        clearMemory,
        previewImage,
        on,
        emit,
        off,
        offAll,
        _postMessageToWeb,
        _invokeJSCallback,
        _invokeJSCallbackAndKeepAlive
    };

    var fundDetail = window.fundDetail = {
        getOptionFundState,
        addOptionFund,
        deleteOptionFund,
        topOptionFund,
        setCalendarRemind,
        openCalendarRemind,
        queryCalendarRemind,
        userLogin,
        shareFundDetail,
        emBuyFund,
        getFundDetail,
        setNavigationBarTitle,
        setNavigationBarColor,
        setNavigationBar,
        setNavigationBarScroll,
        jumpBigChartView,
        jumpBigChartPage,
        closeBigChartPage,
        chartViewClose,
        recordBrowseFund,
        startRefresh,
        endRefresh,
        stopHorizontalScroll,
        openHorizontalScroll,
        showCommentView,
        getBarInteract,
        setBarInteract,
        hideDetailLoading,
        setVideoData,
        setVideoView,
        onVideoVisible,
        onVideoInvisible,
        getCommonStorage,
        getCommonStorageSync,
        setCommonStorage,
        setCommonStorageSync,
        removeCommonStorage,
        removeCommonStorageSync,
        hideFloatingVideoView,
        setPageStorageSync,
        getPageStorageSync,
        getCostShowStateSync,
        onNativeMessageRegistered,
        getABTestSync,
        navigateBack,
        showPortfolioEditDialog,
        navigateToAppAndClose,
        shareFundToDesktop
    };

    var doc = document;
    var readyEvent = doc.createEvent('Events');
    readyEvent.initEvent('fundJSBridgeReady');
    console.log('before dispatchEvent fundJSBridgeReady');
    window.dispatchEvent(readyEvent);
    console.log('dispatchEvent fundJSBridgeReady');
})();